=== modified file 'drizzled/alter_info.cc'
--- drizzled/alter_info.cc	2011-02-17 00:14:13 +0000
+++ drizzled/alter_info.cc	2011-02-28 02:07:11 +0000
@@ -35,7 +35,6 @@
 AlterInfo::AlterInfo() :
   flags(),
   keys_onoff(LEAVE_AS_IS),
-  tablespace_op(NO_TABLESPACE_OP),
   no_parts(0),
   build_method(HA_BUILD_DEFAULT),
   error_if_not_empty(false)

=== modified file 'drizzled/alter_info.h'
--- drizzled/alter_info.h	2011-02-28 01:21:43 +0000
+++ drizzled/alter_info.h	2011-02-28 02:07:11 +0000
@@ -65,13 +65,6 @@
   ALTER_FOREIGN_KEY
 };
 
-enum tablespace_op_type
-{
-  NO_TABLESPACE_OP,
-  DISCARD_TABLESPACE,
-  IMPORT_TABLESPACE
-};
-
 /**
  * Contains information about the parsed CREATE or ALTER TABLE statement.
  *
@@ -88,7 +81,6 @@
   message::AddedFields added_fields_proto;
   std::bitset<32> flags;
   enum enum_enable_or_disable keys_onoff;
-  enum tablespace_op_type tablespace_op;
   uint32_t no_parts;
   enum ha_build_method build_method;
   bool error_if_not_empty;

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-02-28 01:48:03 +0000
+++ drizzled/sql_yacc.yy	2011-02-28 02:07:11 +0000
@@ -1712,18 +1712,12 @@
           /* empty */
         | DISCARD TABLESPACE
           {
-            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
-            statement->alter_info.tablespace_op= DISCARD_TABLESPACE;
-
             message::AlterTable::AlterTableOperation *alter_operation;
             alter_operation= Lex->alter_table()->add_operations();
             alter_operation->set_operation(message::AlterTable::AlterTableOperation::DISCARD_TABLESPACE);
           }
         | IMPORT TABLESPACE
           {
-            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
-            statement->alter_info.tablespace_op= IMPORT_TABLESPACE;
-
             message::AlterTable::AlterTableOperation *alter_operation;
             alter_operation= Lex->alter_table()->add_operations();
             alter_operation->set_operation(message::AlterTable::AlterTableOperation::IMPORT_TABLESPACE);

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2011-02-28 01:48:03 +0000
+++ drizzled/statement/alter_table.cc	2011-02-28 02:07:11 +0000
@@ -703,11 +703,10 @@
 
 /* table_list should contain just one table */
 static int discard_or_import_tablespace(Session *session,
-                                              TableList *table_list,
-                                              enum tablespace_op_type tablespace_op)
+                                        TableList *table_list,
+                                        bool discard)
 {
   Table *table;
-  bool discard;
 
   /*
     Note that DISCARD/IMPORT TABLESPACE always is the only operation in an
@@ -716,8 +715,6 @@
   TransactionServices &transaction_services= TransactionServices::singleton();
   session->set_proc_info("discard_or_import_tablespace");
 
-  discard= test(tablespace_op == DISCARD_TABLESPACE);
-
  /*
    We set this flag so that ha_innobase::open and ::external_lock() do
    not complain when we lock the table
@@ -1380,22 +1377,18 @@
 {
   bool error;
   Table *table;
+  message::AlterTable *alter_table_message= session->getLex()->alter_table();
 
-  if (alter_info->tablespace_op != NO_TABLESPACE_OP)
+  if (alter_table_message->operations_size()
+      && (alter_table_message->operations(0).operation()
+          == message::AlterTable::AlterTableOperation::DISCARD_TABLESPACE
+          || alter_table_message->operations(0).operation()
+          == message::AlterTable::AlterTableOperation::IMPORT_TABLESPACE))
   {
-    message::AlterTable *alter= session->getLex()->alter_table();
-
-    if (alter_info->tablespace_op == DISCARD_TABLESPACE)
-    {
-      assert(alter->operations(0).operation() == message::AlterTable::AlterTableOperation::DISCARD_TABLESPACE);
-    }
-    else if (alter_info->tablespace_op == IMPORT_TABLESPACE)
-    {
-      assert(alter->operations(0).operation() == message::AlterTable::AlterTableOperation::IMPORT_TABLESPACE);
-    }
-
+    bool discard= (alter_table_message->operations(0).operation() ==
+                   message::AlterTable::AlterTableOperation::DISCARD_TABLESPACE);
     /* DISCARD/IMPORT TABLESPACE is always alone in an ALTER Table */
-    return discard_or_import_tablespace(session, table_list, alter_info->tablespace_op);
+    return discard_or_import_tablespace(session, table_list, discard);
   }
 
   session->set_proc_info("init");

